/*
 ******************************************************************************
 *
 * @file     key.c
 * @brief    key module
 *                 
 *
 * @version  1.0
 * @date     2022/08/04   15:00:40
 * @author   Alex Xu
 *
 * Copyright (c) 2013-2099,Tkplusemi Technology Co.,Ltd.
 * All Rights Reserved
 *
 * History:
 * Revision          Date           Author            Desc
 * 1.0.0            2022/08/04      Alex          build this file
 ******************************************************************************/
 /*_____ I N C L U D E S ____________________________________________________*/
#include "key.h"
#include "system.h"
#include "led.h"
#include "sleep.h"
#include "adc.h"
#include "bat.h"

#if KEY_ENABLE
/******************************************************************************\
                          Macro definitions
\******************************************************************************/

/******************************************************************************\
                             Variables definitions
\******************************************************************************/

bit Key_Press_short_irq = 0;
bit Key_Press_l_irq = 0;
bit Key_Press_ll_irq = 0;

bit Key_l_Flag = 0;

bit Hall_Positive_Flg = 0;
bit Hall_Negative_Flg = 0;

idata KEY_EVENT_E Event_key = 0;

/******************************************************************************\
                             Functions definitions
\******************************************************************************/

/*
 *******************************************************************************
 *             void Key_Init(void)
 *
 * Description : Hey Initialization
 *
 * Arguments   :

 * Returns     :

 * Notes       :
 *
 *******************************************************************************
 */
#if 0 
 void Key_Init(void)
{

	SFRADDR = MFP_CTL1;		//Set P05 as key Function
	SFRDATA &= ~0x3C;		
	SFRDATA |= 0x14;

	SFRADDR = PMU_CTL0;
	SFRDATA |= 0x02;		//Key Detect Enable

	//KEY_CTL = 0x04;	//Set all of the functions about KEY are enable.
}
#endif


/*
 *******************************************************************************
 *             void Key_Handler(void)
 *
 * Description : Key Handler --- ѭеã5msг(ʱ2s)Ҫж̧Ŵ
 					CoverStatus --- ָ״̬ṩӦKey¼־λӦô
 *
 * Arguments   : NONE

 * Returns     : NONE

 * Notes       : NONE
 *
 *******************************************************************************
 */

 void Key_Handler(void)
 {
	if( Key_l_Flag )
	{
		Key_Press_l_irq = 0;
		Key_l_Flag = 0;
		/*todo*/
		Event_key = KEY_EVENT_L_2S;

#ifdef _DEBUG_KEY		
		printf("long press\r\n");
#endif
	}

	if( Key_Press_ll_irq )
	{
		Key_Press_ll_irq = 0;
		/*todo*/
		Event_key = KEY_EVENT_LL_8S;
		
#ifdef _DEBUG_KEY
		printf("supper long press\r\n");
#endif
	}	

	if( Key_Press_short_irq )
	{
		Key_Press_short_irq = 0;
		/*todo*/
		Event_key = KEY_EVENT_SHORT;

#ifdef _DEBUG_KEY
		printf("short press\r\n");
#endif

	}	
 }

 #endif
