/*
 ******************************************************************************
 *
 * @file     VOX_Module.c
 * @brief    VOL/R module
 *                 
 *
 * @version  1.0
 * @date     2022/07/18   09:59:40
 * @author   Alex Xu
 *
 * Copyright (c) 2013-2099,Tkplusemi Technology Co.,Ltd.
 * All Rights Reserved
 *
 * History:
 * Revision          Date           Author            Desc
 * 1.0.0            2022/07/18      Alex          build this file
 ******************************************************************************
 */
#include "vox_module.h"
#include "led.h"
#include "system.h"
#include "discharge_module.h"
#include "sleep.h"
#include "userapp.h"

bit Vor_Vout_Enable = OFF;		//OFF:BOOSTʱVOUTTRUE:ж绹IOFF硣
bit Vol_Vout_Enable = OFF;	

bit Vor_GetInto_Box_Flag = 0;    //б־λ
bit Vol_GetInto_Box_Flag = 0;

bit Vor_GetOut_Box_Flag = 0;    //б־λ
bit Vol_GetOut_Box_Flag = 0;

//bit Vor_GetOut_Box_Flag1 = 0;    //б־λ
//bit Vol_GetOut_Box_Flag1 = 0;

#if VOX_ENABLE

/******************************************************************************\
                          Macro definitions
\******************************************************************************/
#define VOX_IOFF_DET_DEBOUNCE		40			//Vox Ioffʱ4sΪ˱֤˳ʼɣʼ

#define VOX_LOADON_DET_DEBOUNCE		2

/******************************************************************************\
                             Variables definitions
\******************************************************************************/
 Vox_State_e Vol_State = VOX_NONE_IN_BOX;

//uint8_t Vol_Ioff_Det_Debounce = 0;

 Vox_State_e Vor_State = VOX_NONE_IN_BOX;

//uint8_t Vor_Ioff_Det_Debounce = 0;

//uint8_t Vol_Output_Debounce = 0;
//uint8_t Vor_Output_Debounce = 0;

bit Vol_Bat_Full_Flag = 0;
bit Vor_Bat_Full_Flag = 0;

bit Vol_Vout_Close_Flag = 0;
bit Vor_Vout_Close_Flag = 0;

//bit Vol_Bat_Low_Flag = 0;
//bit Vor_Bat_Low_Flag = 0;


/******************************************************************************\
                             Functions definitions
\******************************************************************************/

/*
*******************************************************************************
*			 void Vol_Det_Machine(void)
*
* Description : Vol Detect:ʶ (100ms)
*
* Arguments	 : NONE

* Returns	 : NONE

* Notes		 : NONE
*
*******************************************************************************
*/
#if LED_188

bit Vol_Outbox_Disp_Flag = 0;
bit Vol_Intobox_Disp_Flag = 0;

#endif
void Vol_Det_Machine(void)
{
	static uint8_t Vol_Output_Debounce;
	
	/*Vol ÿ200msһ*/
	if( IRQ_FLAG0 & 0x04 )
	{		
	//	Vol_Output_Debounce++;
	//	if( Vol_Output_Debounce >= 2 )		//Vor·200ms¿ADT
		{
	//		Vol_Output_Debounce = 0;
			
			IRQ_FLAG0 = 0x04;
			
			VOX_CTL0 &= ~0x10;					//VOL Disable 5V And Enable VOR ADT
			VOX_CTL0 |= 0x10;					//VOL Enable 5V   			
			
			Vol_Vout_Enable = OFF;
			
			Vol_State = VOX_NONE_IN_BOX;
		}
	}	
	else
	{
		if( gBoost_Prepared_Flag )	
		{	
			switch( Vol_State )
			{
				case VOX_GET_INTO_BOX:				//

					VOX_CTL0 |= 0x10;					//VOL Enable 5V   

					Vol_State = VOX_STAY_IN_BOX;
				break;
				
				case VOX_STAY_IN_BOX:				//ڲ
				
					if( (CHIP_STA1 & 0x24) == 0x24 )						//VoxڳгLoadonIOFFͬʱڵ״̬1֣2س3ﮱ
					{
#if LED_188				
						if( Vol_Intobox_Disp_Flag )         //γӦͼһ
						{
							Vol_Intobox_Disp_Flag = 0;
							
							Vol_GetOut_Box_Flag = 1;			//б־1
							
							Vol_Outbox_Disp_Flag = 1;
						}
#endif					
						Vol_Output_Debounce++;
						if( Vol_Output_Debounce >= VOX_IOFF_DET_DEBOUNCE )			//ת(ֺ)ʱ4s
						{
							Vol_Output_Debounce = 0;

							VOX_CTL0 &= ~0x10;											//VOL Disable 5V And Enable VOR ADT
							
							Vol_Bat_Full_Flag = 1;

							Vol_Vout_Close_Flag = 1;
#ifdef _DEBUG_VOX
							printf("Vol Get Out1\r\n");
#endif	
						}
					}
					else
					if( (CHIP_STA1 & 0x24) == 0x20 )						//۲CHIP_STA1״̬IOFFLoadon˵1ֺ4sڣٴ֣210δ˳ﮱ״̬磻
					{									
						Vol_Output_Debounce = 0;					
#if LED_188		
						if( Vol_Outbox_Disp_Flag )						//4sٴУӦͼһ
						{
							Vol_Outbox_Disp_Flag = 0;
							
							Vol_GetOut_Box_Flag = 0;
							
							LED_On_Timer = 0;
						}

						Vol_Intobox_Disp_Flag = 1;										
#endif
						if( Vol_Bat_Full_Flag )			//ADTģʽ£ֻLoadon״̬˵
						{
							Vol_Vout_Enable = OFF;
#ifdef _DEBUG_VOX
							printf("Vol Full\r\n");
#endif								
						}
						else
						{
							Vol_Vout_Enable = ON;						//־ON
						}						
					}
					else
					if( !(CHIP_STA1 & 0x24) )		//CHIP_STA1loadonioff״̬˵ˡ
					{
						Vol_State = VOX_NONE_IN_BOX; 
#if LED_188					
						Vol_GetInto_Box_Flag = 0;

						Vol_Intobox_Disp_Flag = 0;	
#endif
						Vol_Bat_Full_Flag = 0;

						Vol_Vout_Enable = OFF;
#ifdef _DEBUG_VOX
						printf("Vol Get Out2\r\n");
#endif	
					}
					
				break;

				case VOX_NONE_IN_BOX:				//ղ
				
					VOX_CTL0 &= ~0x10;		//VOL Disable 5V And Enable VOR ADT
					
					Vol_Output_Debounce = 0;
				
					Vol_Vout_Enable = OFF;
				
					if( CHIP_STA1 & 0x20 )    //ADTģʽ³Loadonźţ˵ж֡
					{			
						if( gBoost_Prepared_Flag )
						{				
							Vol_State = VOX_GET_INTO_BOX;

#if DISCHARGE_ENABLE	
							BST_EN = 1; 		//Boost Enable쳣ʱӲرա	
#endif
						}
#if LED_188
						Vol_GetInto_Box_Flag = 1;
#endif

#ifdef _DEBUG_VOX
						printf("VOL_INTO_BOX\r\n");
#endif					
					}
					
				break;

				default:
				break;
			}	
		}
		else			//BoostVOXָ״̬
		{
			Vol_State = VOX_NONE_IN_BOX;
#if LED_188			
			Vol_GetInto_Box_Flag = 0;
#endif		
			Vol_Vout_Enable = OFF;

			VOX_CTL0 &= ~0x10;		//VOL Disable 5V And Enable VOR ADT
		}

	}
}

/*
*******************************************************************************
*			 void Vor_Det_Machine(void)
*
* Description : Vor Detect:ʶ (100ms)
*
* Arguments	 : NONE

* Returns	 : NONE

* Notes		 : NONE
*
*******************************************************************************
*/
#if LED_188
bit Vor_Outbox_Disp_Flag = 0;
bit Vor_Intobox_Disp_Flag = 0;
#endif
void Vor_Det_Machine(void)
{	
	static uint8_t Vor_Output_Debounce;
	
	/*Vor (жϱ־λ)ÿ200msһ*/
	if( IRQ_FLAG0 & 0x08 )
	{		
	//	Vor_Output_Debounce++;
	//	if( Vor_Output_Debounce >= 2 )		//Vor·200ms¿ADT
		{
		//	Vor_Output_Debounce = 0;
			
			IRQ_FLAG0 = 0x08;
			
			VOX_CTL0 &= ~0x20;		//VOR Disable 5V And Enable VOR ADT
			VOX_CTL0 |= 0x20;		//VOR Enable 5V   
			
			Vor_Vout_Enable = OFF;
			
			Vor_State = VOX_NONE_IN_BOX;
		}
	}
	else
	{
		if( gBoost_Prepared_Flag )	
		{
			switch( Vor_State )
			{
				case VOX_GET_INTO_BOX:				//

					VOX_CTL0 |= 0x20;		//VOR Enable 5V   
					
					Vor_State = VOX_STAY_IN_BOX;
					
				break;
				
				case VOX_STAY_IN_BOX:				//ڲ
					
					if( (CHIP_STA1 & 0x88) == 0x88 )						//VoxڳгLoadonIOFFͬʱڵ״̬˵1֣2س3ﮱ
					{
#if LED_188				
						if( Vor_Intobox_Disp_Flag )     //
						{
							Vor_Intobox_Disp_Flag = 0;
							
							Vor_GetOut_Box_Flag = 1;						//Ҷб־1
							
							Vor_Outbox_Disp_Flag = 1;
						}
#endif									
						Vor_Output_Debounce++;
						if( Vor_Output_Debounce >= VOX_IOFF_DET_DEBOUNCE )			//ת(ֺ)ʱ4s
						{
							Vor_Output_Debounce = 0;
				
							VOX_CTL0 &= ~0x20;		//VOR Disable 5V And Enable VOR ADT

							Vor_Bat_Full_Flag = 1;

							Vor_Vout_Close_Flag = 1;
#ifdef _DEBUG_VOX
							printf("Vor Get Out1\r\n");
#endif																														
						}
					}
					else
					if( (CHIP_STA1 & 0x88) == 0x80 )						//۲CHIP_STA1״̬IOFFLoadon˵1ֺ4sڣٴ֣210δ˳ﮱ״̬磻3ﮱ10ӡ
					{				
						Vor_Output_Debounce = 0;	
					
#if LED_188	
						if( Vor_Outbox_Disp_Flag )						//4sٴУӦͼһ
						{
							Vor_Outbox_Disp_Flag = 0;
							
							Vor_GetOut_Box_Flag = 0;
							
							LED_On_Timer = 0;
						}

						Vor_Intobox_Disp_Flag = 1;
#endif
						if( Vor_Bat_Full_Flag )
						{
							Vor_Vout_Enable = OFF;
#ifdef _DEBUG_VOX
							printf("Vor Full\r\n");
#endif								
						}
						else
						{
							Vor_Vout_Enable = ON;
						}
					}
					else
					if( !(CHIP_STA1 & 0x88) )		//CHIP_STA1loadonioff״̬˵ˡ
					{
						Vor_State = VOX_NONE_IN_BOX; 
#if LED_188					
						Vor_Output_Debounce = 0;

						Vor_Intobox_Disp_Flag = 0;
#endif
						Vor_Bat_Full_Flag = 0;

						Vor_Vout_Enable = OFF;
#ifdef _DEBUG_VOX
						printf("Vor Get Out2\r\n");
#endif	

					}

				break;

				case VOX_NONE_IN_BOX:				//ղ

					VOX_CTL0 &= ~0x20;		//VOR Disable 5V And Enable VOR ADT
					
					Vor_Output_Debounce = 0;
				
					Vor_Vout_Enable = OFF;
					
					/* Loadon״̬λڣ˵̡֣*/
					if( CHIP_STA1 & 0x80 )
					{			
						if( gBoost_Prepared_Flag )	
						{
							Vor_State = VOX_GET_INTO_BOX;
							
#if DISCHARGE_ENABLE	
							BST_EN = 1; 		//Boost Enable쳣ʱӲرա	
#endif
						}
#if LED_188
						Vor_GetInto_Box_Flag = 1;
#endif	

#ifdef _DEBUG_VOX
						printf("VOR_INTO_BOX\r\n");
#endif					
					}
					
				break;

				default:
				break;
			}
		}
		else			//BoostVOXָ״̬
		{
			Vor_State = VOX_NONE_IN_BOX;
#if LED_188			
			Vor_GetInto_Box_Flag = 0;
#endif		
			Vor_Vout_Enable = OFF;

			VOX_CTL0 &= ~0x20;		//VOR Disable 5V And Enable VOR ADT
		}		
	}
}

#endif

